;;; SHIP INFO ;;;
(defun display-crew ()
  (let* ((crew-struct (crew-crew-members (player-ship-crew *player-ship*)))
	 (crew-names 
	   (loop for member in crew-struct
		 collect (list (uniq-crew-mem-name member) NIL NIL))))
    (format T "~%CREW DETAILS~%~%")
    (format-table T (list (list (crew-sanity-val (player-ship-crew *player-ship*)))) :column-label '("Sanity"))
    (format T "~%")
    (format-table T crew-names :column-label '("Name" "Buff" "Buff Amount"))))

(defun display-inventory ()
  (let ((inventory-list (list
			 (list "Credits" (player-ship-credits *player-ship*))
			 (list "Petrofuel" (player-inventory-petrofuel (player-ship-inventory *player-ship*)))
			 (list "Gruel" (player-inventory-gruel (player-ship-inventory *player-ship*)))
			 (list "Spice" (player-inventory-spice (player-ship-inventory *player-ship*)))
			 (list "Ammo" (player-inventory-ammo (player-ship-inventory *player-ship*)))
			 (list "Archeotech" (player-inventory-archeotech (player-ship-inventory *player-ship*))))))
    (format T "~%INVENTORY~%")
    (format-table T inventory-list :column-label '("Resource" "Amount"))))


(defun ship-info ()
  (display-crew)
  (display-inventory))
;;; SHIP INFO END ;;;
